<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="90px">
      
      <el-form-item :label="$t('提货点名称')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入名称')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>

      <el-form-item :label="$t('地区')" prop="countryId">
          <el-select v-model="queryParams.countryId" :placeholder="$t('请选择地区')" clearable>
            <el-option v-for="item in countryList" :key="item.id" :label="item.titleZh" :value="item.id"/>
          </el-select>
        </el-form-item>

      <!-- <el-form-item :label="$t('地区')" prop="countryId">
        <el-input v-model="queryParams.countryId" :placeholder="$t('请输入国家')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item> -->
      
      <el-form-item :label="$t('状态')" prop="status">
        <el-select v-model="queryParams.status" :placeholder="$t('请选择状态')" clearable>
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{$t('搜索')}}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{$t('重置')}}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:pickup-loc:create']">{{$t('新增')}}</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['ecw:pickup-loc:export']">{{$t('导出')}}</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list" @sort-change="sortChange">
      <el-table-column :label="$t('序号')" type="index" width="50" />
   
      <el-table-column :label="$t('提货点名称')" align="center" :prop="$l('title')" />
      <el-table-column :label="$t('排序')" sortable="custom" align="center" prop="sort" />

      <el-table-column :label="$t('地区')" align="center" prop="countryId">
          <template slot-scope="scope">
              <span>{{ getCountryName(scope.row.countryId) }}</span>
          </template>
      </el-table-column>
     
      <el-table-column prop="status" :label="$t('状态')" width="100">
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status" :active-value="CommonStatusEnum.ENABLE" :inactive-value="CommonStatusEnum.DISABLE" @change="handleStatusChange(scope.row)" />
        </template>
      </el-table-column>
      
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:pickup-loc:update']">{{$t('修改')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:pickup-loc:delete']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>

    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">

        <el-form-item :label="$t('地区')" prop="countryId">
            <el-radio-group v-model="form.countryId">
              <el-radio v-for="item in countryList" :key="item.id" :label="item.id">{{ $l(item, 'title') }}</el-radio>
            </el-radio-group>
        </el-form-item>
        

        <el-form-item :label="$t('名称')" prop="titleZh">
          <el-input v-model="form.titleZh" :placeholder="$t('请输入名称')" />
        </el-form-item>
        <el-form-item :label="$t('英文名称')" prop="titleEn">
          <el-input v-model="form.titleEn" :placeholder="$t('请输入英文名称')" />
        </el-form-item>
        <el-form-item :label="$t('工作时间')" prop="workTime">
          <el-input v-model="form.workTime" :placeholder="$t('请输入工作时间')" />
        </el-form-item>
        <el-form-item :label="$t('联系方式')" prop="contact">
          <el-input v-model="form.contact" :placeholder="$t('请输入联系方式')" />
        </el-form-item>
        <el-form-item :label="$t('提货点地址')" prop="address">
          <el-input v-model="form.address" :placeholder="$t('请输入提货点地址')" />
        </el-form-item>
        <el-form-item :label="$t('提货点信息')" prop="detailZh">
          <el-input v-model="form.detailZh" :placeholder="$t('请输入提货点信息')" />
        </el-form-item>
        <el-form-item :label="$t('英文提货点信息')" prop="detailEn">
          <el-input v-model="form.detailEn" :placeholder="$t('请输入提货点英文信息')" />
        </el-form-item>
        <el-form-item :label="$t('排序')" prop="sort">
          <el-input v-model="form.sort" :placeholder="$t('请输入排序')" type="number" />
        </el-form-item>

        <el-form-item :label="$t('状态')" prop="status">
          <el-select v-model="form.status" :placeholder="$t('请选择状态')">
            <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="$l(dict, 'label')" :value="parseInt(dict.value)"/>
          </el-select>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{$t('确定')}}</el-button>
        <el-button @click="cancel">{{$t('取消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createPickupLoc, updatePickupLoc, deletePickupLoc, getPickupLoc, getPickupLocPage, exportPickupLocExcel } from "@/api/ecw/pickupLoc";
import {CommonStatusEnum} from '@/utils/constants'
import { getDictDatas, DICT_TYPE } from '@/utils/dict'
import { getListTree } from "@/api/ecw/region";

export default {
  name: "PickupLoc",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,

      //国家信息列表
      countryList: [],  

      // 自提点列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeWorkTime: [],
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        countryId: null,
        titleZh: null,
        titleEn: null,
        contact: null,
        address: null,
        detailZh: null,
        detailEn: null,
        sort: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        countryId: [{ required: true, message: this.$t("地区不能为空"), trigger: "blur" }],
        titleZh: [{ required: true, message: this.$t("名称不能为空"), trigger: "blur" }],
        sort: [{ required: true, message: this.$t("排序不能为空"), trigger: "blur" }],
      },
       // 枚举
      CommonStatusEnum: CommonStatusEnum,
      // 数据字典
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),

      sortProp: null,
      sortType: null,
    };
  },
  created() {
    this.getList();
    this.getCountryList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      params.sortProp = this.sortProp;
      params.sortType = this.sortType;
      this.addBeginAndEndTime(params, this.dateRangeWorkTime, 'workTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getPickupLocPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },

    sortChange(obj) {
      this.sortProp = obj.prop;   //排序字段名称
      this.sortType = obj.order;   //排序方式
      this.queryParams.pageNo = 1;
      this.getList();
    },

    getCountryList() {
        this.queryParams.treeType = 1;
        getListTree(this.queryParams).then(response => {
          this.countryList = response.data;
      });
    },

    getCountryName(countryId) {
      for(let index in this.countryList) {
        let country = this.countryList[index];
        if(country.id == countryId) return $l(country, 'title');
      }
    },

    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        countryId: undefined,
        titleZh: undefined,
        titleEn: undefined,
        workTime: undefined,
        contact: undefined,
        address: undefined,
        detailZh: undefined,
        detailEn: undefined,
        sort: undefined,
        status: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeWorkTime = [];
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = this.$t("添加自提点");
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getPickupLoc(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t("修改自提点");
      });
    },

     handleStatusChange(row) {
      let text = row.status === CommonStatusEnum.ENABLE ? this.$t("启用") : this.$t("停用");
      this.$modal.confirm(this.$t('确认要{action} {title} 吗?', {
        action: text,
        title: this.$l(row, 'title')
      })).then(function() {
        return updatePickupLoc(row);

      }).then(() => {
        this.$modal.msgSuccess(text + this.$t("成功"));
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE
          : CommonStatusEnum.ENABLE;
      });
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updatePickupLoc(this.form).then(response => {
            this.$modal.msgSuccess(this.$t("修改成功"));
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createPickupLoc(this.form).then(response => {
          this.$modal.msgSuccess(this.$t("新增成功"));
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm(this.$t('是否确认删除自提点编号为{id}的数据项?', {id})).then(function() {
          return deletePickupLoc(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t("删除成功"));
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeWorkTime, 'workTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm(this.$t('是否确认导出所有自提点数据项?')).then(() => {
          this.exportLoading = true;
          return exportPickupLocExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
